/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include "xvicon.h"
#include "shell.h"
#include "global.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


void XVicon(char *filename,char **icon)
{
  char *xvpic;
  char *text;
  int character=0;
  FILE *xvfile;
  int i;
  xvpic=malloc(strlen(GetPath())+strlen(".xvpics/")+
	       strlen(filename)+1);
  strcpy(xvpic,GetPath());
  strcat(xvpic,".xvpics/");
  strcat(xvpic,filename);
  if (xvpic[0]=='~' && xvpic[1]=='/')
    xvpic[0]='.';
  if ((xvfile=fopen(xvpic, "r")) != NULL) {
    for (i=0;i<strlen(xvpic)+100;i++)
      character=fgetc(xvfile);
    fclose(xvfile);
    if (character!=-1) {
      free(*icon);
      *icon=malloc(strlen(xvpic)+1);
      strcpy(*icon,xvpic);
    } else {
      text=malloc(strlen("rm ")+strlen(xvpic)+1);
      strcpy(text,"rm ");
      strcat(text,xvpic);
      usershellsystem(text);
      free(text);
    }    
  }
  free(xvpic);
}
